



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>WEB应用中的普通Java程序如何读取资源文件</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">WEB应用中的普通Java程序如何读取资源文件</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 22:42:48 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<div>
<pre class="prettyprint linenums"> package cn.itcast;

 import java.io.IOException;<br />
 import java.io.PrintWriter;

 import javax.servlet.ServletException;<br />
 import javax.servlet.http.HttpServlet;<br />
 import javax.servlet.http.HttpServletRequest;<br />
 import javax.servlet.http.HttpServletResponse;

 //servlet调用其他程序，在其他程序中何如读取资源文件（通过类装载器）<br />
 public class ServletDemo3 extends HttpServlet {

     public void doGet(HttpServletRequest request, HttpServletResponse response)<br />
             throws ServletException, IOException {

         UserDao dao = new UserDao();<br />
         dao.find();

     }

     public void doPost(HttpServletRequest request, HttpServletResponse response)<br />
             throws ServletException, IOException {

     }

 }</pre>
</div>
</div>
<div>
<div>
<pre class="prettyprint linenums"> package cn.itcast;

 import java.io.FileInputStream;<br />
 import java.io.FileNotFoundException;<br />
 import java.io.IOException;<br />
 import java.io.InputStream;<br />
 import java.util.Properties;

 //如果读取资源文件的程序不是servlet的话，就只能通过类装载器去读<br />
 public class UserDao {

     private static Properties dbconfig = new Properties();<br />
     static {<br />
         InputStream in = UserDao.class.getClassLoader().getResourceAsStream(<br />
                 "db.properties");<br />
         try {<br />
             dbconfig.load(in);<br />
         } catch (IOException e) {<br />
             throw new ExceptionInInitializerError(e);<br />
         }<br />
     }<br />
     //以下代码虽然可以读取资源文件数据，但是无法获取更新后的数据<br />
     public void update() throws IOException {

         System.out.println(dbconfig.getProperty("url"));<br />
     }

     //通过类装载的方式得到资源文件位置，再通过传统方式读取资源文件的数据，这样可以读取更新后的数据<br />
     public void find() throws IOException {<br />
         String path = UserDao.class.getClassLoader().getResource("db.properties").getPath();<br />
         FileInputStream in = new FileInputStream(path);

         Properties dbconfig = new Properties();<br />
         dbconfig.load(in);

         System.out.println(dbconfig.getProperty("url"));

     }

 }</pre>
</div>
</div>
<div>
<div>
<pre class="prettyprint linenums"> &lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />
 &lt;web-app version="2.4"<br />
     xmlns="http://java.sun.com/xml/ns/j2ee"<br />
     xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"<br />
     xsi:schemaLocation="http://java.sun.com/xml/ns/j2ee<br />
     http://java.sun.com/xml/ns/j2ee/web-app_2_4.xsd"&gt;

 &lt;servlet&gt;<br />
     &lt;servlet-name&gt;ServletDemo1&lt;/servlet-name&gt;<br />
     &lt;servlet-class&gt;cn.itcast.ServletDemo1&lt;/servlet-class&gt;<br />
 &lt;/servlet&gt;<br />
   &lt;servlet&gt;<br />
     &lt;servlet-name&gt;ServletDemo3&lt;/servlet-name&gt;<br />
     &lt;servlet-class&gt;cn.itcast.ServletDemo3&lt;/servlet-class&gt;<br />
   &lt;/servlet&gt;

 &lt;servlet-mapping&gt;<br />
     &lt;servlet-name&gt;ServletDemo1&lt;/servlet-name&gt;<br />
     &lt;url-pattern&gt;/ServletDemo1&lt;/url-pattern&gt;<br />
 &lt;/servlet-mapping&gt;<br />
   &lt;servlet-mapping&gt;<br />
     &lt;servlet-name&gt;ServletDemo3&lt;/servlet-name&gt;<br />
     &lt;url-pattern&gt;/servlet/ServletDemo3&lt;/url-pattern&gt;<br />
   &lt;/servlet-mapping&gt;

   &lt;welcome-file-list&gt;<br />
     &lt;welcome-file&gt;index.jsp&lt;/welcome-file&gt;<br />
   &lt;/welcome-file-list&gt;<br />
 &lt;/web-app&gt;</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m96021j9.html">slf4j log4j logback关系详解和相关用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd532j9.html">windows批处理语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnlelj9.html">cookie操作（jquery的cookie插件源码）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1mxym9.html">Python之MySql操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydrkzgq.html">《samba搭建win客户端和linux客户端的区别》</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvr161q.html">phpstorm8 设置及license key</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm62nl9.html">从零开始学习MySQL1---MySQL基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz02vw8.html">alv行可编辑时带出描述</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gemxk48.html">KMP算法（具体求串的next&lbrack;n&rsqb;）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me2z60q.html">树莓派学习笔记 1 -- 硬件的需求以及raspbian系统的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg4m778.html">html 背景透明文字不透明</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p7kln8.html">Angular  - - ngChange、ngChecked、ngClick、ngDblclick</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zk5g39.html">防火墙上开放Oracle服务端口1521的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpk6dzq.html">设计模式原则&lpar;3&rpar;--Dependency Inversion  Principle&lpar;DIP&rpar;--依赖倒转原则</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljp5wk9.html">phalcon&mdash;&mdash;Paginator分页</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzr3kl8.html">linux下主机用户管理（完整详情）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgep5r8.html">解决centos7&period;0安装mysql后出现access defind for user&commat;&amp;&num;39&semi;localhost&amp;&num;39&semi;的错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j10o349.html">C&num;读写Excel实践笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyr50gq.html">Confluence 6 配置 Office 转换器</a>
		</li>
						<li><a href="https://www.batexi.com/a/96040jv9.html">leetcode &mdash; reverse-nodes-in-k-group</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/wq1onx48.html">CSS3-html，样式与样式表的创建，选择器</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zpp139.html">实现窗体随着鼠标移动&lpar;控件&rpar;--《用delphi开发共享软件》-15&period;1任务管理器</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2ee1vq.html">sqoop学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8oprvpq.html">Python基础3- 变量与数字</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyn3km9.html">Codeforces 611C New Year and Domino（二维前缀和）</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rplv48.html">Codeforces 343D Water Tree（DFS序 &plus; 线段树）</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7vyj1q.html">Struts2上传大小限制</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k6gx7q.html">【原】iOS学习之KVC原理</a>
			</li>
						<li><a href="https://www.batexi.com/a/49g6w77q.html">Android MultiDex</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j65z4q.html">topcoder SRM 622 DIV2 BoxesDiv2</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
